package com.hai.dao;

import com.hai.entity.HighActivityUserLotteryNum;
import com.hai.entity.HighActivityUserLotteryNumExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighActivityUserLotteryNumMapper extends HighActivityUserLotteryNumMapperExt {
    @SelectProvider(type=HighActivityUserLotteryNumSqlProvider.class, method="countByExample")
    long countByExample(HighActivityUserLotteryNumExample example);

    @DeleteProvider(type=HighActivityUserLotteryNumSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighActivityUserLotteryNumExample example);

    @Delete({
        "delete from high_activity_user_lottery_num",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_activity_user_lottery_num (activity_info_id, user_id, ",
        "lottery_num, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{activityInfoId,jdbcType=BIGINT}, #{userId,jdbcType=BIGINT}, ",
        "#{lotteryNum,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighActivityUserLotteryNum record);

    @InsertProvider(type=HighActivityUserLotteryNumSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighActivityUserLotteryNum record);

    @SelectProvider(type=HighActivityUserLotteryNumSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="lottery_num", property="lotteryNum", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighActivityUserLotteryNum> selectByExample(HighActivityUserLotteryNumExample example);

    @Select({
        "select",
        "id, activity_info_id, user_id, lottery_num, create_time, update_time, ext_1, ",
        "ext_2, ext_3",
        "from high_activity_user_lottery_num",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="activity_info_id", property="activityInfoId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="lottery_num", property="lotteryNum", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighActivityUserLotteryNum selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighActivityUserLotteryNumSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighActivityUserLotteryNum record, @Param("example") HighActivityUserLotteryNumExample example);

    @UpdateProvider(type=HighActivityUserLotteryNumSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighActivityUserLotteryNum record, @Param("example") HighActivityUserLotteryNumExample example);

    @UpdateProvider(type=HighActivityUserLotteryNumSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighActivityUserLotteryNum record);

    @Update({
        "update high_activity_user_lottery_num",
        "set activity_info_id = #{activityInfoId,jdbcType=BIGINT},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "lottery_num = #{lotteryNum,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighActivityUserLotteryNum record);
}