package com.hai.dao;

import com.hai.entity.HighPraise;
import com.hai.entity.HighPraiseExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighPraiseMapper extends HighPraiseMapperExt {
    @SelectProvider(type=HighPraiseSqlProvider.class, method="countByExample")
    long countByExample(HighPraiseExample example);

    @DeleteProvider(type=HighPraiseSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighPraiseExample example);

    @Delete({
        "delete from high_praise",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_praise (child_order_id, goods_type, ",
        "goods_id, user_id, user_avatar, ",
        "user_name, praise_star, ",
        "praise_content, praise_imgs, ",
        "create_time, modify_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{childOrderId,jdbcType=BIGINT}, #{goodsType,jdbcType=INTEGER}, ",
        "#{goodsId,jdbcType=BIGINT}, #{userId,jdbcType=BIGINT}, #{userAvatar,jdbcType=VARCHAR}, ",
        "#{userName,jdbcType=VARCHAR}, #{praiseStar,jdbcType=INTEGER}, ",
        "#{praiseContent,jdbcType=VARCHAR}, #{praiseImgs,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{modifyTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighPraise record);

    @InsertProvider(type=HighPraiseSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighPraise record);

    @SelectProvider(type=HighPraiseSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="child_order_id", property="childOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_avatar", property="userAvatar", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="praise_star", property="praiseStar", jdbcType=JdbcType.INTEGER),
        @Result(column="praise_content", property="praiseContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="praise_imgs", property="praiseImgs", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="modify_time", property="modifyTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighPraise> selectByExample(HighPraiseExample example);

    @Select({
        "select",
        "id, child_order_id, goods_type, goods_id, user_id, user_avatar, user_name, praise_star, ",
        "praise_content, praise_imgs, create_time, modify_time, `status`, ext_1, ext_2, ",
        "ext_3",
        "from high_praise",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="child_order_id", property="childOrderId", jdbcType=JdbcType.BIGINT),
        @Result(column="goods_type", property="goodsType", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_avatar", property="userAvatar", jdbcType=JdbcType.VARCHAR),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="praise_star", property="praiseStar", jdbcType=JdbcType.INTEGER),
        @Result(column="praise_content", property="praiseContent", jdbcType=JdbcType.VARCHAR),
        @Result(column="praise_imgs", property="praiseImgs", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="modify_time", property="modifyTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighPraise selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighPraiseSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighPraise record, @Param("example") HighPraiseExample example);

    @UpdateProvider(type=HighPraiseSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighPraise record, @Param("example") HighPraiseExample example);

    @UpdateProvider(type=HighPraiseSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighPraise record);

    @Update({
        "update high_praise",
        "set child_order_id = #{childOrderId,jdbcType=BIGINT},",
          "goods_type = #{goodsType,jdbcType=INTEGER},",
          "goods_id = #{goodsId,jdbcType=BIGINT},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "user_avatar = #{userAvatar,jdbcType=VARCHAR},",
          "user_name = #{userName,jdbcType=VARCHAR},",
          "praise_star = #{praiseStar,jdbcType=INTEGER},",
          "praise_content = #{praiseContent,jdbcType=VARCHAR},",
          "praise_imgs = #{praiseImgs,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "modify_time = #{modifyTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighPraise record);
}