package com.hai.dao;

import com.hai.entity.HighTyAgentOilStation;
import com.hai.entity.HighTyAgentOilStationExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighTyAgentOilStationMapper extends HighTyAgentOilStationMapperExt {
    @SelectProvider(type=HighTyAgentOilStationSqlProvider.class, method="countByExample")
    long countByExample(HighTyAgentOilStationExample example);

    @DeleteProvider(type=HighTyAgentOilStationSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighTyAgentOilStationExample example);

    @Delete({
        "delete from high_ty_agent_oil_station",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_ty_agent_oil_station (organization_id, organization_name, ",
        "ty_agent_id, ty_agent_name, ",
        "ty_salesman_id, ty_salesman_name, ",
        "oil_station_id, oil_station_name, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{organizationId,jdbcType=BIGINT}, #{organizationName,jdbcType=VARCHAR}, ",
        "#{tyAgentId,jdbcType=BIGINT}, #{tyAgentName,jdbcType=VARCHAR}, ",
        "#{tySalesmanId,jdbcType=BIGINT}, #{tySalesmanName,jdbcType=VARCHAR}, ",
        "#{oilStationId,jdbcType=BIGINT}, #{oilStationName,jdbcType=VARCHAR}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighTyAgentOilStation record);

    @InsertProvider(type=HighTyAgentOilStationSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighTyAgentOilStation record);

    @SelectProvider(type=HighTyAgentOilStationSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="organization_id", property="organizationId", jdbcType=JdbcType.BIGINT),
        @Result(column="organization_name", property="organizationName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ty_agent_id", property="tyAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="ty_agent_name", property="tyAgentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ty_salesman_id", property="tySalesmanId", jdbcType=JdbcType.BIGINT),
        @Result(column="ty_salesman_name", property="tySalesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_station_id", property="oilStationId", jdbcType=JdbcType.BIGINT),
        @Result(column="oil_station_name", property="oilStationName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighTyAgentOilStation> selectByExample(HighTyAgentOilStationExample example);

    @Select({
        "select",
        "id, organization_id, organization_name, ty_agent_id, ty_agent_name, ty_salesman_id, ",
        "ty_salesman_name, oil_station_id, oil_station_name, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from high_ty_agent_oil_station",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="organization_id", property="organizationId", jdbcType=JdbcType.BIGINT),
        @Result(column="organization_name", property="organizationName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ty_agent_id", property="tyAgentId", jdbcType=JdbcType.BIGINT),
        @Result(column="ty_agent_name", property="tyAgentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ty_salesman_id", property="tySalesmanId", jdbcType=JdbcType.BIGINT),
        @Result(column="ty_salesman_name", property="tySalesmanName", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_station_id", property="oilStationId", jdbcType=JdbcType.BIGINT),
        @Result(column="oil_station_name", property="oilStationName", jdbcType=JdbcType.VARCHAR),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighTyAgentOilStation selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighTyAgentOilStationSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighTyAgentOilStation record, @Param("example") HighTyAgentOilStationExample example);

    @UpdateProvider(type=HighTyAgentOilStationSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighTyAgentOilStation record, @Param("example") HighTyAgentOilStationExample example);

    @UpdateProvider(type=HighTyAgentOilStationSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighTyAgentOilStation record);

    @Update({
        "update high_ty_agent_oil_station",
        "set organization_id = #{organizationId,jdbcType=BIGINT},",
          "organization_name = #{organizationName,jdbcType=VARCHAR},",
          "ty_agent_id = #{tyAgentId,jdbcType=BIGINT},",
          "ty_agent_name = #{tyAgentName,jdbcType=VARCHAR},",
          "ty_salesman_id = #{tySalesmanId,jdbcType=BIGINT},",
          "ty_salesman_name = #{tySalesmanName,jdbcType=VARCHAR},",
          "oil_station_id = #{oilStationId,jdbcType=BIGINT},",
          "oil_station_name = #{oilStationName,jdbcType=VARCHAR},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighTyAgentOilStation record);
}